#define MIN_CONSEC_GOOD_FRAMES 4
#define FRAME_HEADER_SIZE 4
#define MIN_FRAME_SIZE 21
#define NUM_SAMPLES 4


typedef struct {
 unsigned long	sync;
 unsigned int	version;
 unsigned int	layer;
 unsigned int	crc;
 unsigned int	bitrate;
 unsigned int	freq;
 unsigned int	padding;
 unsigned int	extension;
 unsigned int	mode;
 unsigned int	mode_extension;
 unsigned int	copyright;
 unsigned int	original;
 unsigned int	emphasis;
} mp3header;

typedef struct {
 char title[31];
 char artist[31];
 char album[31];
 char year[5];
 char comment[31];
 unsigned char track[1];
 unsigned char genre[1];
} id3tag;


typedef struct {
 char *filename;
 FILE *file;
 off_t datasize;
 int header_isvalid;
 mp3header header;
 int id3_isvalid;
 id3tag id3;
 int vbr;
 float vbr_average;
 int seconds;
 int frames;
 int badframes;
} mp3info;



int get_header(FILE *file,mp3header *header);

int header_bitrate(mp3header *h);

int sameConstant(mp3header *h1, mp3header *h2);

int header_layer(mp3header *h);

char *header_emphasis(mp3header *h);

int get_mp3_info(mp3info *mp3,int scantype, int fullscan_vbr);

int do_lookup_table(const char *genre);

int get_id3(mp3info *mp3);

char *pad(char *string, int length);

char *unpad(char *string);

int get_next_header(mp3info *mp3);

int frame_length(mp3header *header);

int write_tag(mp3info *mp3);

int header_frequency(mp3header *h);

char *header_mode(mp3header *h);

int get_first_header(mp3info *mp3,long startpos);

char *get_update(int sock);



enum VBR_REPORT { VBR_VARIABLE, VBR_AVERAGE, VBR_MEDIAN };
enum SCANTYPE { SCAN_NONE, SCAN_QUICK, SCAN_FULL };


